﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace TimePlanner
{
    class Program
    {
        static void Main(string[] args)
        {

            StreamReader sr;
            long oldTime, newTime, diffSec;


            // -- Vychozi navratovy kod --
            System.Environment.ExitCode = 1;
            

            // -- Test argumentu --
            if (args.Length != 1)
            {
                Console.WriteLine("Usage: TimePlanner t\n       t=time in sec\n");
                return;
            }
            try
            {
                diffSec = Int32.Parse(args[0]);
            }
            catch
            {
                Console.WriteLine("ERROR: Argument t is not numeric");
                return;
            }


            // -- Nazev souboru s casovou znackou --
            string timestampFileName = AppDomain.CurrentDomain.BaseDirectory + "timestamp.last";


            // -- Vytvoreni neexistujicicho souboru a otevreni --
            try
            {
                if (!File.Exists(timestampFileName))
                {
                    File.Create(timestampFileName).Close();
                }
                sr = new StreamReader(timestampFileName);
            }
            catch
            {
                Console.WriteLine("ERROR: Unable to create or open file " + timestampFileName);
                return;
            }


            // -- Nacteni puvodniho casu --
            try
            {
                oldTime = Int64.Parse(sr.ReadLine());
            }
            catch
            {
                oldTime = 0;
            }
            sr.Close();


            // -- Vyhodnoceni casu, zapis do souboru a nastaveni retval --
            newTime = (long)(DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0)).TotalSeconds;
            if (newTime > (oldTime + diffSec))
            {
                try
                {
                    System.IO.File.WriteAllText(timestampFileName, newTime.ToString());
                }
                catch
                {
                    Console.WriteLine("ERROR: Unable to write file " + timestampFileName);
                }
                Console.WriteLine("Allowed - return code 0");
                System.Environment.ExitCode = 0;
                return;
            }
            else
            {
                Console.WriteLine("Denied - return code 1");
                return;
            }


        }
    }
}
